/*
****************************************************************************

              Copyright 1991, by FUJITSU LIMITED
              Copyright 1991, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Auther: Riki	Kawaguchi       FUJITSU LIMITED
	A.	Yukisita        FUJITSU LIMITED
	Hideki  Hiura           (hhiura@Sun.COM) Sun Microsystems, Inc.

****************************************************************************
*/

#ifndef lint
#ident  "@(#)HttStatus.c	1.13    93/02/12 SMI"
#endif

#ifdef X_LOCALE
#include <X11/Xlocale.h>
#else
#include <locale.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#if XlibSpecificationRelease != 5
#include <X11/XlibR5.h>
#endif /* XlibSpecificationRelease */
#include "XSunExt.h"

#include <X11/Xutil.h>
#include <X11/Xresource.h>

#include <X11/keysymdef.h>

#include "Htt.h"
extern	htt_t	*htt;

#include "XSunIMProt.h"
#include "HttXsfSun.h"

extern void	DisplayStatus_wcs() ;
extern int	Xsf_XIMTextToWcs();

/*
 * Drawing Functions...
 *	XsfStatusDraw,
 */
extern void
XsfStatusDraw( ic, sds )
    FXimp_Client		 *ic ;
    XIMStatusDrawCallbackStruct  *sds ;
{
    int mode;
    FXimp_Client *focus_in_client=GET_HTT_VALUE(htt,focus_in_client);
    int status_feedback=GET_HTT_VALUE(htt,status_feedback);

    if (status_feedback == FEEDBACK_STIPPLE) {
        if (ic == focus_in_client)
           mode = highlight;
        else
           mode = stipple;
    }
    else
        mode = highlight;

    if ( ic->status_message ) {
        free( ic->status_message );
        ic->status_message = NULL;
    }
    ic->status_length = Xsf_XIMTextToWcs( sds->data.text, &ic->status_message );
    if ((status_feedback != FEEDBACK_UNMAP) ||
        ((status_feedback == FEEDBACK_UNMAP) &&
         (ic == focus_in_client)))
        DisplayStatus_wcs( ic, mode );
    return;
}
